muz(jan).
muz(josef).
muz(frantisek).
muz(martin).

zena(jana).
zena(zuzana).
zena(ivana).
zena(petra).

manzelepom(jan,jana).
manzelepom(zuzana,josef).
manzelepom(ivana,frantisek).

manzele(X,Y) :-
    manzelepom(X,Y).
manzele(X,Y) :-
    manzelepom(Y,X).

manzelka(Zena,Muz) :-
    zena(Zena),
    manzele(Zena,Muz).

manzel(Muz,Zena) :-
    muz(Muz),
    manzele(Muz,Zena).

matka(jana,josef).
matka(jana,ivana).
matka(zuzana,martin).
matka(ivana,petra).

otec(Otec,Dite) :-
    manzel(Otec,X),
    matka(X,Dite).

rodic(Dospely,Dite) :-
    matka(Dospely,Dite).

rodic(Dospely,Dite) :-
    otec(Dospely,Dite).

babicka(B,V) :-
    matka(B,X),
    rodic(X,V).

dedecek(D,V) :-
    otec(D,X),
    rodic(X,V).

dite(D,R) :-
    rodic(R,D).

vnuk(V,P) :-
    muz(V),
    babicka(P,V).

vnuk(V,P) :-
    muz(V),
    dedecek(P,V).

vnucka(V,P) :-
    zena(V),
    babicka(P,V).

vnucka(V,P) :-
    zena(V),
    dedecek(P,V).

vnouce(X,Y) :-
    vnuk(X,Y).

vnouce(X,Y) :-
    vnucka(X,Y).

sourozenec(X,Y) :-
    matka(M,X),
    matka(M,Y),
    X =\= Y.
